/* STEVEN FORD'S ASSEMBLY MACROS
 * HE IS SO PROUD OF THEM :)
 * SO.... USE THEM WISELY!!!!!
 */


//Interrupt Macros
#define "Disable_Interrupts ( )" as @" DI"
#define "Enable_Interrupts ( )" as @" EI"
#define "Interrupt_Mode (", mode ,")" as @" IM ", @mode

//Low level key reading Macros
#define "LL_Ready_KB (", val ,")" as @" LD A, ", @val ,@"\n OUT (1), A"
#define "LL_Read_KB (", var ,")" as @" IN A, (1)\n LD (", @&var ,@"), A"

//Low level reading of arrow keys
#define "Read_Arrow_Keys (", var ,")" as @" LD A, $FE\n OUT (1), A\n IN A, (1)\n LD (", @&var ,@"), A"

//Wait (to slow down program flow)
#define "wait(", var ,")" as @" LD HL, (", @&var ,@")\n LD B, H\n LD C, L\n LD HL, 0\n LD DE, 0\n LDIR"

// *********Graphics Macros***********  //
//Update display only, or display and graph buffer
#define "Update_Display_Only ( ) " as @" SET 1, (IY + 2)\n RES bufferOnly, (IY + plotFlag3)"
#define "Update_Display_and_GrBuffer ( ) " as @" RES 1, (IY + 2)\n RES bufferOnly, (IY + plotFlag3)"

// Full screen Darw
#define "Full_Screen_Draw()" as @"fullScrnDraw, (IY + apiFlg4)"

//Draw Clear Rectangle
#define "Clear_Rectangle (", ulpxcol ,"-", ulpxrow ,"-", lrpxcol ,"-", lrpxrow ,")" as @" LD A, (", @&ulpxrow ,@")\n LD H, A\n LD A, (", @&ulpxcol ,@")\n LD L, A\n LD A, (", @&lrpxrow ,@")\n LD D, A\n LD A, (", @&lrpxcol ,@")\n LD E, A\n B_CALL(_ClearRect)"
#define "Clear_Rectangle_Const (", ulpxcol ,"-", ulpxrow ,"-", lrpxcol ,"-", lrpxrow ,")" as @" LD H, ", @ulpxrow ,@"\n LD L, ", @ulpxcol ,@"\n LD D, ", @lrpxrow ,@"\n LD E, ", @lrpxcol ,@"\n B_CALL(_ClearRect)"

//Draw Line
#define "Line (", x1 ,"-", y1 ,"-", x2 ,"-", y2 ,"-", mode ,")" as @" LD A, (", @&x1 ,@")\n LD B, A\n LD A, (", @&y1 ,@")\n LD C, A\n LD A, (", @&x2 ,@")\n LD D, A\n LD A, (", @&y2 ,@")\n LD E, A\n LD H, ", @mode ,@"\n LD L, 0\n B_CALL(_ILine)"
#define "Line_Const (", x1 ,"-", y1 ,"-", x2 ,"-", y2 ,"-", mode ,")" as @" LD B, ", @x1 ,@"\n LD C, ", @y1 ,@"\n LD D, ", @x2 ,@"\n LD E, ", @y2 ,@"\n LD H, ", @mode ,@"\n B_CALL(_ILine)"

//Draw Rectangle Border
#define "Rectangle_Border (", ulpxcol ,"-", ulpxrow ,"-", lrpxcol ,"-", lrpxrow ,")" as @" LD A, (", @&ulpxrow ,@")\n LD H, A\n LD A, (", @&ulpxcol ,@")\n LD L, A\n LD A, (", @&lrpxrow ,@")\n LD D, A\n LD A, (", @&lrpxcol ,@")\n LD E, A\n B_CALL(_DrawRectBorder)"
#define "Rectangle_Border_Const (", ulpxcol ,"-", ulpxrow ,"-", lrpxcol ,"-", lrpxrow ,")" as @" LD H, ", @ulpxrow ,@"\n LD L, ", @ulpxcol ,@"\n LD D, ", @lrpxrow ,@"\n LD E, ", @lrpxcol ,@"\n B_CALL(_DrawRectBorder)"

//Clear Rectangle with a Border
#define "Clear_Rectangle_with_Border (", ulpxcol ,"-", ulpxrow ,"-", lrpxcol ,"-", lrpxrow ,")" as @" LD A, (", @&ulpxrow ,@")\n LD H, A\n LD A, (", @&ulpxcol ,@")\n LD L, A\n LD A, (", @&lrpxrow ,@")\n LD D, A\n LD A, (", @&lrpxcol ,@")\n LD E, A\n B_CALL(_DrawRectBorderClear)"
#define "Clear_Rectangle_with_Border_Const (", ulpxcol ,"-", ulpxrow ,"-", lrpxcol ,"-", lrpxrow ,")" as @" LD H, ", @ulpxrow ,@"\n LD L, ", @ulpxcol ,@"\n LD D, ", @lrpxrow ,@"\n LD E, ", @lrpxcol ,@"\n B_CALL(_DrawRectBorderClear)"

// Erase rectangle border
#define "Erase_Rectangle_Border (", ulpxcol ,"-", ulpxrow ,"-", lrpxcol ,"-", lrpxrow ,")" as @" LD A, (", @&ulpxrow ,@")\n LD H, A\n LD A, (", @&ulpxcol ,@")\n LD L, A\n LD A, (", @&lrpxrow ,@")\n LD D, A\n LD A, (", @&lrpxcol ,@")\n LD E, A\n B_CALL(_EraseRectBorder)"
#define "Erase_Rectangle_Border_Const (", ulpxcol ,"-", ulpxrow ,"-", lrpxcol ,"-", lrpxrow ,")" as @" LD H, ", @ulpxrow ,@"\n LD L, ", @ulpxcol ,@"\n LD D, ", @lrpxrow ,@"\n LD E, ", @lrpxcol ,@"\n B_CALL(_EraseRectBorder)"

// Full rectangle
#define "Full_Rectangle (", ulpxcol ,"-", ulpxrow ,"-", lrpxcol ,"-", lrpxrow ,")" as @" LD A, (", @&ulpxrow ,@")\n LD H, A\n LD A, (", @&ulpxcol ,@")\n LD L, A\n LD A, (", @&lrpxrow ,@")\n LD D, A\n LD A, (", @&lrpxcol ,@")\n LD E, A\n B_CALL(_FillRect)"
#define "Full_Rectangle_Const (", ulpxcol ,"-", ulpxrow ,"-", lrpxcol ,"-", lrpxrow ,")" as @" LD H, ", @ulpxrow ,@"\n LD L, ", @ulpxcol ,@"\n LD D, ", @lrpxrow ,@"\n LD E, ", @lrpxcol ,@"\n B_CALL(_FillRect)"

//Clear Graph Buffer
#define "Clear_GBuffer ( )" as @" B_CALL(_GrBufClr)"

//Copy buffer to display
#define "Copy_GBuffer_to_Screen ( )" as @" B_CALL(_GrBufCpy)"

//Use Fast Circle
#define "Fast_Circle_On ( )" as @" SET useFastCirc, (IY + plotFlag3)"
#define "Fast_Circle_Off( )" as @" RES useFastCirc, (IY + plotFlag3)"

//Draw Circle
#define "Draw_Circle (", x ,"-", y ,"-", r ,")" as @" LD A, (", @&x ,@")\n LD (curGX2), A\n LD (curGX), A\n LD A, (", @&y ,@")\n LD (curGY2), A\n LD B, A\n LD A, (", @&r ,@")\n ADD A, B\n LD (curGY), A\n B_CALL(_GrphCirc)"
#define "Draw_Circle_Const (", x ,"-", y ,"-", r ,")" as @" LD A, ", @x ,@"\n LD (curGX2), A\n LD (curGX), A\n LD A, ", @y ,@"\n LD (curGY2), A\n LD B, A\n LD A, (", @r ,@")\n ADD A, B\n LD (curGY), A\n B_CALL(_GrphCirc)"

//Force Full Screen
#define "Force_Full_Screen ( )" as @" B_CALL(_ForceFullScreen)"

//Inverted Rectangle
#define "Invert_Rectangle (", ulpxcol ,"-", ulpxrow ,"-", lrpxcol ,"-", lrpxrow ,")" as @" LD A, (", @&ulpxrow ,@")\n LD H, A\n LD A, (", @&ulpxcol ,@")\n LD L, A\n LD A, (", @&lrpxrow ,@")\n LD D, A\n LD A, (", @&lrpxcol ,@")\n LD E, A\n B_CALL(_InvertRect)"
#define "Invert_Rectangle_Const (", ulpxcol ,"-", ulpxrow ,"-", lrpxcol ,"-", lrpxrow ,")" as @" LD H, ", @ulpxrow ,@"\n LD L, ", @ulpxcol ,@"\n LD D, ", @lrpxrow ,@"\n LD E, ", @lrpxcol ,@"\n B_CALL(_InvertRect)"

//Points
#define "Point_On (", x ,"-", y, ")" as @" LD A, (", @&x ,@")\n LD B, A\n LD A, (", @&y ,@")\n LD C, A\n B_CALL(_PointOn)"
#define "Point_On_Const (", x ,"-", y, ")" as @" LD B, ", @x ,@"\n LD C, ", @y ,@"\n B_CALL(_PointOn)"
#define "Point_Change (", x ,"-", y ,")" as @" LD A, (", @&x ,@")\n LD B, A\n LD A, (", @&y ,@")\n LD C, A\n LD D, 2\n B_CALL(_IPoint)"
#define "Point_Change_Const (", x ,"-", y ,")" as @" LD B, ", @x ,@"\n LD C, ", @y ,@"\n LD D, 2\n B_CALL(_IPoint)"
#define "Point_Off (", x ,"-", y ,")" as @" LD A, (", @&x ,@")\n LD B, A\n LD A, (", @&y ,@")\n LD C, A\n LD D, 0\n B_CALL(_IPoint)"
#define "Point_Off_Const (", x ,"-", y ,")" as @" LD B, ", @x ,@"\n LD C, ", @y ,@"\n LD D, 0\n B_CALL(_IPoint)"

//Draw to Gbuffer only
#define "Draw_GBuffer_Only ( )" as @" SET bufferOnly, (IY + plotFlag3)"

#eof